function [Vdiff]=findliqequivalt(lin,model,fspace,cbase)

global model fspace Ns1 Us1 istars1 valfunmb S1 alldata Ns2 Us2 istars2 Errs2 S2 os zs e2 w2 valfunbase

valfunbasetemp=zeros(length(alldata(:,1)),1);
valfuntransf=zeros(length(alldata(:,1)),1);
for k=1:128
    Y=alldata(:,5);
    L=alldata(:,24)+lin;
    U=e2(k,1);
    ist=e2(k,2);
    UE=U*e2(k,3);
    def=((L./Y.*UE)<(model.slbar+model.clbar));
    iable=((L./Y.*UE)>(model.slbar+model.clbar+ist));
    %do for defaulters  (just need consumption)
    if max(def)==1
       valfunbasetemp(def==1)=funeval(cbase,fspace,[(0.01*os(def==1,1)).^(1-model.rho)/(1-model.rho)  zs(def==1,1)]).*((Y(def==1)/UE).^(1-model.rho));
    end
    %do for non-investors
    if max(iable==0 & def==0)==1
       valfunbasetemp(iable==0 & def==0)=funeval(cbase,fspace,[(L(iable==0 & def==0)./Y(iable==0 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==0 & def==0,1)]).*((Y(iable==0 & def==0)/UE).^(1-model.rho));        
    end
    %do for potential investors
    if max(iable)==1
       [valfunbasetemp(iable==1 & def==0) d(iable==1 & def==0)]=max([funeval(cbase,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(iable==1 & def==0,1)]).*((Y(iable==1 & def==0)/UE).^(1-model.rho)) funeval(cbase,fspace,[(L(iable==1 & def==0)./Y(iable==1 & def==0)*UE-model.slbar-model.clbar+0.01-ist).^(1-model.rho)/(1-model.rho)  ist*os(iable==1 & def==0,1)]).*((Y(iable==1 & def==0)/UE).^(1-model.rho))],[],2);
    end 
    valfuntransf=valfuntransf+valfunbasetemp*w2(k);
end
Vdiff=(valfuntransf-valfunmb).^2;




