%This files creates the long run simulated predictions and regressions.  It
%requires the results file millbahtwithsim.mat, which is created by the
%program CalibrationSimulationTable5.m.  It saves the results in
%millbahtlongrun.mat.  

!del Section543_longrun.txt
clear all
global model fspace Ns1 Us1 istars1 valfunmb S1 alldata cbase os zs

load millbahtwithsim;
clear Ns2 Us2 istars2 Errs2 Cm X betaCm sig2Cm stdbetaCm betaDm sig2Dm stdbetaDm betaIm sig2Im stdbetaIm betaDEFm sig2DEFm stdbetaDEFm betaYgrowthm sig2Ygrowthm stdbetaYgrowthm 

S2=300;
Ns2=exp(model.VarN^0.5*randn(nHH,S2,7));
Us2=exp(model.Varu^0.5*randn(nHH,S2,8));
Errs2=exp(model.VarErr^0.5*randn(nHH,S2,8));
istars2=exp(model.Varistar^0.5*randn(nHH,S2,7)+model.Eistar);
betaCm=zeros(18,S2);
betaDm=zeros(18,S2);
betaIm=zeros(18,S2);
betaIonlym=zeros(18,S2);
betaDEFm=zeros(18,S2);
betaYgrowthm=zeros(18,S2);
stdbetaCm=zeros(18,S2);
stdbetaDm=zeros(18,S2);
stdbetaIm=zeros(18,S2);
stdbetaIonlym=zeros(18,S2);
stdbetaDEFm=zeros(18,S2);
stdbetaYgrowthm=zeros(18,S2);

iable=zeros(nHH,1);
s=zeros(nHH,1);
def6=zeros(nHH,S2);
Y6=zeros(nHH,S2);
L6=zeros(nHH,S2);
d6=zeros(nHH,S2);
C6=zeros(nHH,S2);
I6=zeros(nHH,S2);
def7=zeros(nHH,S2);
Y7=zeros(nHH,S2);
L7=zeros(nHH,S2);
d7=zeros(nHH,S2);
C7=zeros(nHH,S2);
I7=zeros(nHH,S2);
def8=zeros(nHH,S2);
Y8=zeros(nHH,S2);
L8=zeros(nHH,S2);
d8=zeros(nHH,S2);
C8=zeros(nHH,S2);
I8=zeros(nHH,S2);
def9=zeros(nHH,S2);
Y9=zeros(nHH,S2);
L9=zeros(nHH,S2);
d9=zeros(nHH,S2);
C9=zeros(nHH,S2);
I9=zeros(nHH,S2);
def10=zeros(nHH,S2);
Y10=zeros(nHH,S2);
L10=zeros(nHH,S2);
d10=zeros(nHH,S2);
C10=zeros(nHH,S2);
I10=zeros(nHH,S2);
def11=zeros(nHH,S2);
Y11=zeros(nHH,S2);
L11=zeros(nHH,S2);
d11=zeros(nHH,S2);
C11=zeros(nHH,S2);
I11=zeros(nHH,S2);
def12=zeros(nHH,S2);
Y12=zeros(nHH,S2);
L12=zeros(nHH,S2);
d12=zeros(nHH,S2);
C12=zeros(nHH,S2);
I12=zeros(nHH,S2);
sdef6=zeros(nHH,S2);
sdef7=zeros(nHH,S2);
sdef8=zeros(nHH,S2);
sdef9=zeros(nHH,S2);
sdef10=zeros(nHH,S2);
sdef11=zeros(nHH,S2);
sdef12=zeros(nHH,S2);
s6=zeros(nHH,S2);
s7=zeros(nHH,S2);
s8=zeros(nHH,S2);
s9=zeros(nHH,S2);
s10=zeros(nHH,S2);
s11=zeros(nHH,S2);
s12=zeros(nHH,S2);
%we'll leave data in matrix form for routines, but use this as a key:

% Y1=alldata(:,1);
% Y2=alldata(:,2);
% Y3=alldata(:,3);
% Y4=alldata(:,4);
% Y5=alldata(:,5);
% Y6=alldata(:,6);
% Y7=alldata(:,7);
% I1=alldata(:,8);
% I2=alldata(:,9);
% I3=alldata(:,10);
% I4=alldata(:,11);
% I5=alldata(:,12);
% I6=alldata(:,13);
% I7=alldata(:,14);
% DEF2=alldata(:,15);
% DEF3=alldata(:,16);
% DEF4=alldata(:,17);
% DEF5=alldata(:,18);
% DEF6=alldata(:,19);
% DEF7=alldata(:,20);
% L5=alldata(:,21);
% C2=alldata(:,22);
% C3=alldata(:,23);
% C4=alldata(:,24);
% C5=alldata(:,25);
% C6=alldata(:,26);
% C7=alldata(:,27);
% villnum=alldata(:,28)
% villsize=alldata(:,29)

for ss=1:numslbar
    model.slbar=slbargrid(ss);
    if (max(mbgridnum==ss)>0)      
        %calculate baselineconsumption, investment, and savings
        for k=1:S2
            %let's figure out 2002 predictions
            Y6(mbgridnum==ss,k)=(model.G*Ns2(mbgridnum==ss,k,1).*alldata(mbgridnum==ss,5)./(Us2(mbgridnum==ss,k,1).*Errs2(mbgridnum==ss,k,1))+model.R*alldata(mbgridnum==ss,12)).*Us2(mbgridnum==ss,k,2);
            L6(mbgridnum==ss,k)=(alldata(mbgridnum==ss,21)-alldata(mbgridnum==ss,25)-alldata(mbgridnum==ss,12)).*model.r+Y6(mbgridnum==ss,k);
            def6(mbgridnum==ss,k)=(L6(mbgridnum==ss,k)./Y6(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,2)<(model.slbar+model.clbar));
            sdef6(mbgridnum==ss,k)=L6(mbgridnum==ss,k)-(model.slbar+model.clbar)*Y6(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,2);
            iable(mbgridnum==ss)=(L6(mbgridnum==ss,k)./Y6(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,2)>(model.slbar+model.clbar+istars2(mbgridnum==ss,k,1)));
            %do for defaulters  (just need consumption)
            if max(mbgridnum==ss & def6(:,k)==1)==1
                d6(mbgridnum==ss & def6(:,k)==1,k)=0;
                C6(mbgridnum==ss & def6(:,k)==1,k)=model.clbar*Y6(mbgridnum==ss & def6(:,k)==1,k)./Us2(mbgridnum==ss & def6(:,k)==1,k,2);
                s6(mbgridnum==ss & def6(:,k)==1,k)=model.slbar*Y6(mbgridnum==ss & def6(:,k)==1,k)./Us2(mbgridnum==ss & def6(:,k)==1,k,2);
            end
            %do for non-investors
                if max(mbgridnum==ss & iable==0 & def6(:,k)==0)==1
                d6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)=0;
                C6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)=funeval(cconsmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)./Y6(mbgridnum==ss & iable==0 & def6(:,k)==0,k).*Us2(mbgridnum==ss & iable==0 & def6(:,k)==0,k,2)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==0 & def6(:,k)==0,1)]).*Y6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)./Us2(mbgridnum==ss & iable==0 & def6(:,k)==0,k,2);
                s6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)=L6(mbgridnum==ss & iable==0 & def6(:,k)==0,k)-C6(mbgridnum==ss & iable==0 & def6(:,k)==0,k);
            end
            %do for potential investors
            if max(mbgridnum==ss & iable==1)==1
                [valfun, d6(mbgridnum==ss & iable==1,k)]=max([funeval(cmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==1,k)./Y6(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,2)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) funeval(cmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==1,k)./Y6(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,2)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,1)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,1)])],[],2);
                d6(mbgridnum==ss & iable==1,k)=d6(mbgridnum==ss & iable==1,k)-1;
                C6(mbgridnum==ss & iable==1,k)=((1-d6(mbgridnum==ss & iable==1,k)).*funeval(cconsmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==1,k)./Y6(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,2)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) + d6(mbgridnum==ss & iable==1,k).*funeval(cconsmat(:,ss),fspace,[(L6(mbgridnum==ss & iable==1,k)./Y6(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,2)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,1)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,1)])).*Y6(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,2);
                s6(mbgridnum==ss & iable==1,k)=L6(mbgridnum==ss & iable==1,k)-C6(mbgridnum==ss & iable==1,k)-d6(mbgridnum==ss & iable==1,k).*istars2(mbgridnum==ss & iable==1,k,1).*Y6(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,2);
            end
            I6(mbgridnum==ss,k)=d6(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,1).*Y6(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,2);
            Y7(mbgridnum==ss,k)=(model.G*Ns2(mbgridnum==ss,k,2)+model.R*d6(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,1)).*Y6(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,3)./Us2(mbgridnum==ss,k,2);
            L7(mbgridnum==ss,k)=s6(mbgridnum==ss,k).*model.r+Y7(mbgridnum==ss,k);
            def7(mbgridnum==ss,k)=(L7(mbgridnum==ss,k)./Y7(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,3)<(model.slbar+model.clbar));
            sdef7(mbgridnum==ss,k)=L7(mbgridnum==ss,k)-(model.slbar+model.clbar)*Y7(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,3);
            iable(mbgridnum==ss)=(L7(mbgridnum==ss,k)./Y7(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,3)>(model.slbar+model.clbar+istars2(mbgridnum==ss,k,2)));
            %do for defaulters  (just need consumption)
            if max(mbgridnum==ss & def7(:,k)==1)==1
                d7(mbgridnum==ss & def7(:,k)==1,k)=0;
                C7(mbgridnum==ss & def7(:,k)==1,k)=model.clbar*Y7(mbgridnum==ss & def7(:,k)==1,k)./Us2(mbgridnum==ss & def7(:,k)==1,k,3);
                s7(mbgridnum==ss & def7(:,k)==1,k)=model.slbar*Y7(mbgridnum==ss & def7(:,k)==1,k)./Us2(mbgridnum==ss & def7(:,k)==1,k,3);
            end
            %do for non-investors
            if max(mbgridnum==ss & iable==0 & def7(:,k)==0)==1
                d7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)=0;
                C7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)=funeval(cconsmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)./Y7(mbgridnum==ss & iable==0 & def7(:,k)==0,k).*Us2(mbgridnum==ss & iable==0 & def7(:,k)==0,k,3)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==0 & def7(:,k)==0,1)]).*Y7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)./Us2(mbgridnum==ss & iable==0 & def7(:,k)==0,k,3);
                s7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)=L7(mbgridnum==ss & iable==0 & def7(:,k)==0,k)-C7(mbgridnum==ss & iable==0 & def7(:,k)==0,k);
            end
            %do for potential investors
            if max(mbgridnum==ss & iable==1)==1
                [valfun, d7(mbgridnum==ss & iable==1,k)]=max([funeval(cmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==1,k)./Y7(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,3)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) funeval(cmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==1,k)./Y7(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,3)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,2)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,2)])],[],2);
                d7(mbgridnum==ss & iable==1,k)=d7(mbgridnum==ss & iable==1,k)-1;
                C7(mbgridnum==ss & iable==1,k)=((1-d7(mbgridnum==ss & iable==1,k)).*funeval(cconsmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==1,k)./Y7(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,3)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) + d7(mbgridnum==ss & iable==1,k).*funeval(cconsmat(:,ss),fspace,[(L7(mbgridnum==ss & iable==1,k)./Y7(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,3)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,2)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,2)])).*Y7(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,3);
                s7(mbgridnum==ss & iable==1,k)=L7(mbgridnum==ss & iable==1,k)-C7(mbgridnum==ss & iable==1,k)-d7(mbgridnum==ss & iable==1).*istars2(mbgridnum==ss & iable==1,k,2).*Y7(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,3);
            end
            I7(mbgridnum==ss,k)=d7(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,2).*Y7(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,3);
            Y8(mbgridnum==ss,k)=(model.G*Ns2(mbgridnum==ss,k,3)+model.R*d7(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,2)).*Y7(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,4)./Us2(mbgridnum==ss,k,3);
            L8(mbgridnum==ss,k)=s7(mbgridnum==ss,k).*model.r+Y8(mbgridnum==ss,k);
            def8(mbgridnum==ss,k)=(L8(mbgridnum==ss,k)./Y8(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,4)<(model.slbar+model.clbar));
            sdef8(mbgridnum==ss,k)=L8(mbgridnum==ss,k)-(model.slbar+model.clbar)*Y8(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,4);
            iable(mbgridnum==ss)=(L8(mbgridnum==ss,k)./Y8(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,4)>(model.slbar+model.clbar+istars2(mbgridnum==ss,k,3)));
            %do for defaulters  (just need consumption)
            if max(mbgridnum==ss & def8(:,k)==1)==1
                d8(mbgridnum==ss & def8(:,k)==1,k)=0;
                C8(mbgridnum==ss & def8(:,k)==1,k)=model.clbar*Y8(mbgridnum==ss & def8(:,k)==1,k)./Us2(mbgridnum==ss & def8(:,k)==1,k,4);
                s8(mbgridnum==ss & def8(:,k)==1,k)=model.slbar*Y8(mbgridnum==ss & def8(:,k)==1,k)./Us2(mbgridnum==ss & def8(:,k)==1,k,4);
            end
            %do for non-investors
            if max(mbgridnum==ss & iable==0 & def8(:,k)==0)==1
                d8(mbgridnum==ss & iable==0 & def8(:,k)==0,k)=0;
                C8(mbgridnum==ss & iable==0 & def8(:,k)==0,k)=funeval(cconsmat(:,ss),fspace,[(L8(mbgridnum==ss & iable==0 & def8(:,k)==0,k)./Y8(mbgridnum==ss & iable==0 & def8(:,k)==0,k).*Us2(mbgridnum==ss & iable==0 & def8(:,k)==0,k,4)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==0 & def8(:,k)==0,1)]).*Y8(mbgridnum==ss & iable==0 & def8(:,k)==0,k)./Us2(mbgridnum==ss & iable==0 & def8(:,k)==0,k,4);
                s8(mbgridnum==ss & iable==0 & def8(:,k)==0,k)=L8(mbgridnum==ss & iable==0 & def8(:,k)==0,k)-C8(mbgridnum==ss & iable==0 & def8(:,k)==0,k);
            end
            %do for potential investors
            if max(mbgridnum==ss & iable==1)==1
                [valfun, d8(mbgridnum==ss & iable==1,k)]=max([funeval(cmat(:,ss),fspace,[(L8(mbgridnum==ss & iable==1,k)./Y8(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,4)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) funeval(cmat(:,ss),fspace,[(L8(mbgridnum==ss & iable==1,k)./Y8(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,4)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,3)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,3)])],[],2);
                d8(mbgridnum==ss & iable==1,k)=d8(mbgridnum==ss & iable==1,k)-1;
                C8(mbgridnum==ss & iable==1,k)=((1-d8(mbgridnum==ss & iable==1,k)).*funeval(cconsmat(:,ss),fspace,[(L8(mbgridnum==ss & iable==1,k)./Y8(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,4)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) + d8(mbgridnum==ss & iable==1,k).*funeval(cconsmat(:,ss),fspace,[(L8(mbgridnum==ss & iable==1,k)./Y8(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,4)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,3)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,3)])).*Y8(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,4);
                s8(mbgridnum==ss & iable==1,k)=L8(mbgridnum==ss & iable==1,k)-C8(mbgridnum==ss & iable==1,k)-d8(mbgridnum==ss & iable==1).*istars2(mbgridnum==ss & iable==1,k,3).*Y8(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,4);
            end
            I8(mbgridnum==ss,k)=d8(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,3).*Y8(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,4);
            Y9(mbgridnum==ss,k)=(model.G*Ns2(mbgridnum==ss,k,4)+model.R*d8(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,3)).*Y8(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,5)./Us2(mbgridnum==ss,k,4);
            L9(mbgridnum==ss,k)=s8(mbgridnum==ss,k).*model.r+Y9(mbgridnum==ss,k);
            def9(mbgridnum==ss,k)=(L9(mbgridnum==ss,k)./Y9(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,5)<(model.slbar+model.clbar));
            sdef9(mbgridnum==ss,k)=L9(mbgridnum==ss,k)-(model.slbar+model.clbar)*Y9(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,5);
            iable(mbgridnum==ss)=(L9(mbgridnum==ss,k)./Y9(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,5)>(model.slbar+model.clbar+istars2(mbgridnum==ss,k,4)));
            %do for defaulters  (just need consumption)
            if max(mbgridnum==ss & def9(:,k)==1)==1
                d9(mbgridnum==ss & def9(:,k)==1,k)=0;
                C9(mbgridnum==ss & def9(:,k)==1,k)=model.clbar*Y9(mbgridnum==ss & def9(:,k)==1,k)./Us2(mbgridnum==ss & def9(:,k)==1,k,5);
                s9(mbgridnum==ss & def9(:,k)==1,k)=model.slbar*Y9(mbgridnum==ss & def9(:,k)==1,k)./Us2(mbgridnum==ss & def9(:,k)==1,k,5);
            end
            %do for non-investors
            if max(mbgridnum==ss & iable==0 & def9(:,k)==0)==1
                d9(mbgridnum==ss & iable==0 & def9(:,k)==0,k)=0;
                C9(mbgridnum==ss & iable==0 & def9(:,k)==0,k)=funeval(cconsmat(:,ss),fspace,[(L9(mbgridnum==ss & iable==0 & def9(:,k)==0,k)./Y9(mbgridnum==ss & iable==0 & def9(:,k)==0,k).*Us2(mbgridnum==ss & iable==0 & def9(:,k)==0,k,5)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==0 & def9(:,k)==0,1)]).*Y9(mbgridnum==ss & iable==0 & def9(:,k)==0,k)./Us2(mbgridnum==ss & iable==0 & def9(:,k)==0,k,5);
                s9(mbgridnum==ss & iable==0 & def9(:,k)==0,k)=L9(mbgridnum==ss & iable==0 & def9(:,k)==0,k)-C9(mbgridnum==ss & iable==0 & def9(:,k)==0,k);
            end
            %do for potential investors
            if max(mbgridnum==ss & iable==1)==1
                [valfun, d9(mbgridnum==ss & iable==1,k)]=max([funeval(cmat(:,ss),fspace,[(L9(mbgridnum==ss & iable==1,k)./Y9(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,5)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) funeval(cmat(:,ss),fspace,[(L9(mbgridnum==ss & iable==1,k)./Y9(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,5)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,4)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,4)])],[],2);
                d9(mbgridnum==ss & iable==1,k)=d9(mbgridnum==ss & iable==1,k)-1;
                C9(mbgridnum==ss & iable==1,k)=((1-d9(mbgridnum==ss & iable==1,k)).*funeval(cconsmat(:,ss),fspace,[(L9(mbgridnum==ss & iable==1,k)./Y9(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,5)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) + d9(mbgridnum==ss & iable==1,k).*funeval(cconsmat(:,ss),fspace,[(L9(mbgridnum==ss & iable==1,k)./Y9(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,5)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,4)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,4)])).*Y9(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,5);
                s9(mbgridnum==ss & iable==1,k)=L9(mbgridnum==ss & iable==1,k)-C9(mbgridnum==ss & iable==1,k)-d9(mbgridnum==ss & iable==1).*istars2(mbgridnum==ss & iable==1,k,4).*Y9(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,5);
            end
            I9(mbgridnum==ss,k)=d9(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,4).*Y9(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,5);
            Y10(mbgridnum==ss,k)=(model.G*Ns2(mbgridnum==ss,k,4)+model.R*d9(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,4)).*Y9(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,6)./Us2(mbgridnum==ss,k,5);
            L10(mbgridnum==ss,k)=s9(mbgridnum==ss,k).*model.r+Y10(mbgridnum==ss,k);
            def10(mbgridnum==ss,k)=(L10(mbgridnum==ss,k)./Y10(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,6)<(model.slbar+model.clbar));
            sdef10(mbgridnum==ss,k)=L10(mbgridnum==ss,k)-(model.slbar+model.clbar)*Y10(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,6);
            iable(mbgridnum==ss)=(L10(mbgridnum==ss,k)./Y10(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,6)>(model.slbar+model.clbar+istars2(mbgridnum==ss,k,5)));
            %do for defaulters  (just need consumption)
            if max(mbgridnum==ss & def10(:,k)==1)==1
                d10(mbgridnum==ss & def10(:,k)==1,k)=0;
                C10(mbgridnum==ss & def10(:,k)==1,k)=model.clbar*Y10(mbgridnum==ss & def10(:,k)==1,k)./Us2(mbgridnum==ss & def10(:,k)==1,k,6);
                s10(mbgridnum==ss & def10(:,k)==1,k)=model.slbar*Y10(mbgridnum==ss & def10(:,k)==1,k)./Us2(mbgridnum==ss & def10(:,k)==1,k,6);
            end
            %do for non-investors
            if max(mbgridnum==ss & iable==0 & def10(:,k)==0)==1
                d10(mbgridnum==ss & iable==0 & def10(:,k)==0,k)=0;
                C10(mbgridnum==ss & iable==0 & def10(:,k)==0,k)=funeval(cconsmat(:,ss),fspace,[(L10(mbgridnum==ss & iable==0 & def10(:,k)==0,k)./Y10(mbgridnum==ss & iable==0 & def10(:,k)==0,k).*Us2(mbgridnum==ss & iable==0 & def10(:,k)==0,k,6)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==0 & def10(:,k)==0,1)]).*Y10(mbgridnum==ss & iable==0 & def10(:,k)==0,k)./Us2(mbgridnum==ss & iable==0 & def10(:,k)==0,k,6);
                s10(mbgridnum==ss & iable==0 & def10(:,k)==0,k)=L10(mbgridnum==ss & iable==0 & def10(:,k)==0,k)-C10(mbgridnum==ss & iable==0 & def10(:,k)==0,k);
            end
            %do for potential investors
            if max(mbgridnum==ss & iable==1)==1
                [valfun, d10(mbgridnum==ss & iable==1,k)]=max([funeval(cmat(:,ss),fspace,[(L10(mbgridnum==ss & iable==1,k)./Y10(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,6)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) funeval(cmat(:,ss),fspace,[(L10(mbgridnum==ss & iable==1,k)./Y10(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,6)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,5)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,5)])],[],2);
                d10(mbgridnum==ss & iable==1,k)=d10(mbgridnum==ss & iable==1,k)-1;
                C10(mbgridnum==ss & iable==1,k)=((1-d10(mbgridnum==ss & iable==1,k)).*funeval(cconsmat(:,ss),fspace,[(L10(mbgridnum==ss & iable==1,k)./Y10(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,6)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) + d10(mbgridnum==ss & iable==1,k).*funeval(cconsmat(:,ss),fspace,[(L10(mbgridnum==ss & iable==1,k)./Y10(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,6)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,5)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,5)])).*Y10(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,6);
                s10(mbgridnum==ss & iable==1,k)=L10(mbgridnum==ss & iable==1,k)-C10(mbgridnum==ss & iable==1,k)-d10(mbgridnum==ss & iable==1).*istars2(mbgridnum==ss & iable==1,k,5).*Y10(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,6);
            end
            I10(mbgridnum==ss,k)=d10(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,5).*Y10(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,6);
            Y11(mbgridnum==ss,k)=(model.G*Ns2(mbgridnum==ss,k,5)+model.R*d10(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,5)).*Y10(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,7)./Us2(mbgridnum==ss,k,6);
            L11(mbgridnum==ss,k)=s10(mbgridnum==ss,k).*model.r+Y11(mbgridnum==ss,k);
            def11(mbgridnum==ss,k)=(L11(mbgridnum==ss,k)./Y11(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,7)<(model.slbar+model.clbar));
            sdef11(mbgridnum==ss,k)=L11(mbgridnum==ss,k)-(model.slbar+model.clbar)*Y11(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,7);
            iable(mbgridnum==ss)=(L11(mbgridnum==ss,k)./Y11(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,7)>(model.slbar+model.clbar+istars2(mbgridnum==ss,k,6)));
            %do for defaulters  (just need consumption)
            if max(mbgridnum==ss & def11(:,k)==1)==1
                d11(mbgridnum==ss & def11(:,k)==1,k)=0;
                C11(mbgridnum==ss & def11(:,k)==1,k)=model.clbar*Y11(mbgridnum==ss & def11(:,k)==1,k)./Us2(mbgridnum==ss & def11(:,k)==1,k,7);
                s11(mbgridnum==ss & def11(:,k)==1,k)=model.slbar*Y11(mbgridnum==ss & def11(:,k)==1,k)./Us2(mbgridnum==ss & def11(:,k)==1,k,7);
            end
            %do for non-investors
            if max(mbgridnum==ss & iable==0 & def11(:,k)==0)==1
                d11(mbgridnum==ss & iable==0 & def11(:,k)==0,k)=0;
                C11(mbgridnum==ss & iable==0 & def11(:,k)==0,k)=funeval(cconsmat(:,ss),fspace,[(L11(mbgridnum==ss & iable==0 & def11(:,k)==0,k)./Y11(mbgridnum==ss & iable==0 & def11(:,k)==0,k).*Us2(mbgridnum==ss & iable==0 & def11(:,k)==0,k,7)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==0 & def11(:,k)==0,1)]).*Y11(mbgridnum==ss & iable==0 & def11(:,k)==0,k)./Us2(mbgridnum==ss & iable==0 & def11(:,k)==0,k,7);
                s11(mbgridnum==ss & iable==0 & def11(:,k)==0,k)=L11(mbgridnum==ss & iable==0 & def11(:,k)==0,k)-C11(mbgridnum==ss & iable==0 & def11(:,k)==0,k);
            end
            %do for potential investors
            if max(mbgridnum==ss & iable==1)==1
                [valfun, d11(mbgridnum==ss & iable==1,k)]=max([funeval(cmat(:,ss),fspace,[(L11(mbgridnum==ss & iable==1,k)./Y11(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,7)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) funeval(cmat(:,ss),fspace,[(L11(mbgridnum==ss & iable==1,k)./Y11(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,7)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,6)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,6)])],[],2);
                d11(mbgridnum==ss & iable==1,k)=d11(mbgridnum==ss & iable==1,k)-1;
                C11(mbgridnum==ss & iable==1,k)=((1-d11(mbgridnum==ss & iable==1,k)).*funeval(cconsmat(:,ss),fspace,[(L11(mbgridnum==ss & iable==1,k)./Y11(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,7)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) + d11(mbgridnum==ss & iable==1,k).*funeval(cconsmat(:,ss),fspace,[(L11(mbgridnum==ss & iable==1,k)./Y11(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,7)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,6)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,6)])).*Y11(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,7);
                s11(mbgridnum==ss & iable==1,k)=L11(mbgridnum==ss & iable==1,k)-C11(mbgridnum==ss & iable==1,k)-d11(mbgridnum==ss & iable==1).*istars2(mbgridnum==ss & iable==1,k,6).*Y11(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,7);
            end
            I11(mbgridnum==ss,k)=d11(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,6).*Y11(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,7);
            Y12(mbgridnum==ss,k)=(model.G*Ns2(mbgridnum==ss,k,6)+model.R*d11(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,6)).*Y11(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,8)./Us2(mbgridnum==ss,k,7);
            L12(mbgridnum==ss,k)=s11(mbgridnum==ss,k).*model.r+Y12(mbgridnum==ss,k);
            def12(mbgridnum==ss,k)=(L12(mbgridnum==ss,k)./Y12(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,8)<(model.slbar+model.clbar));
            sdef12(mbgridnum==ss,k)=L12(mbgridnum==ss,k)-(model.slbar+model.clbar)*Y12(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,8);
            iable(mbgridnum==ss)=(L12(mbgridnum==ss,k)./Y12(mbgridnum==ss,k).*Us2(mbgridnum==ss,k,8)>(model.slbar+model.clbar+istars2(mbgridnum==ss,k,7)));
            %do for defaulters  (just need consumption)
            if max(mbgridnum==ss & def12(:,k)==1)==1
                d12(mbgridnum==ss & def12(:,k)==1,k)=0;
                C12(mbgridnum==ss & def12(:,k)==1,k)=model.clbar*Y12(mbgridnum==ss & def12(:,k)==1,k)./Us2(mbgridnum==ss & def12(:,k)==1,k,8);
                s12(mbgridnum==ss & def12(:,k)==1,k)=model.slbar*Y12(mbgridnum==ss & def12(:,k)==1,k)./Us2(mbgridnum==ss & def12(:,k)==1,k,8);
            end
            %do for non-investors
            if max(mbgridnum==ss & iable==0 & def12(:,k)==0)==1
                d12(mbgridnum==ss & iable==0 & def12(:,k)==0,k)=0;
                C12(mbgridnum==ss & iable==0 & def12(:,k)==0,k)=funeval(cconsmat(:,ss),fspace,[(L12(mbgridnum==ss & iable==0 & def12(:,k)==0,k)./Y12(mbgridnum==ss & iable==0 & def12(:,k)==0,k).*Us2(mbgridnum==ss & iable==0 & def12(:,k)==0,k,8)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==0 & def12(:,k)==0,1)]).*Y12(mbgridnum==ss & iable==0 & def12(:,k)==0,k)./Us2(mbgridnum==ss & iable==0 & def12(:,k)==0,k,8);
                s12(mbgridnum==ss & iable==0 & def12(:,k)==0,k)=L12(mbgridnum==ss & iable==0 & def12(:,k)==0,k)-C12(mbgridnum==ss & iable==0 & def12(:,k)==0,k);
            end
            %do for potential investors
            if max(mbgridnum==ss & iable==1)==1
                [valfun, d12(mbgridnum==ss & iable==1,k)]=max([funeval(cmat(:,ss),fspace,[(L12(mbgridnum==ss & iable==1,k)./Y12(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,8)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) funeval(cmat(:,ss),fspace,[(L12(mbgridnum==ss & iable==1,k)./Y12(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,8)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,7)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,7)])],[],2);
                d12(mbgridnum==ss & iable==1,k)=d12(mbgridnum==ss & iable==1,k)-1;
                C12(mbgridnum==ss & iable==1,k)=((1-d12(mbgridnum==ss & iable==1,k)).*funeval(cconsmat(:,ss),fspace,[(L12(mbgridnum==ss & iable==1,k)./Y12(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,8)-model.slbar-model.clbar+0.01).^(1-model.rho)/(1-model.rho)  zs(mbgridnum==ss & iable==1,1)]) + d12(mbgridnum==ss & iable==1,k).*funeval(cconsmat(:,ss),fspace,[(L12(mbgridnum==ss & iable==1,k)./Y12(mbgridnum==ss & iable==1,k).*Us2(mbgridnum==ss & iable==1,k,8)-model.slbar-model.clbar+0.01-istars2(mbgridnum==ss & iable==1,k,7)).^(1-model.rho)/(1-model.rho)  istars2(mbgridnum==ss & iable==1,k,7)])).*Y12(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,8);
                s12(mbgridnum==ss & iable==1,k)=L12(mbgridnum==ss & iable==1,k)-C12(mbgridnum==ss & iable==1,k)-d12(mbgridnum==ss & iable==1).*istars2(mbgridnum==ss & iable==1,k,7).*Y12(mbgridnum==ss & iable==1,k)./Us2(mbgridnum==ss & iable==1,k,8);
            end
            I12(mbgridnum==ss,k)=d10(mbgridnum==ss,k).*istars2(mbgridnum==ss,k,5).*Y10(mbgridnum==ss,k)./Us2(mbgridnum==ss,k,6);

        end
    end
end
%now add in the measurement error
for k=1:S2
    Y6(:,k)=Y6(:,k).*Errs2(:,k,2);
    Y7(:,k)=Y7(:,k).*Errs2(:,k,3);
    Y8(:,k)=Y8(:,k).*Errs2(:,k,4);
    Y9(:,k)=Y9(:,k).*Errs2(:,k,5);
    Y10(:,k)=Y10(:,k).*Errs2(:,k,6);
    Y11(:,k)=Y11(:,k).*Errs2(:,k,7);
    Y12(:,k)=Y12(:,k).*Errs2(:,k,8);
end

%X=[invHH*year==2002 invHH*year==2003 invHH*year==2004 invHH*year==2005 invHH*year==2006 invHH*year==2007 invHH*year==2008 year==1998 year==1999 year==2000 year==2001  year==2002 year==2003 year==2004 year==2005]
X=[zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   intervention./alldata(:,34) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) intervention./alldata(:,34) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) intervention./alldata(:,34) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) intervention./alldata(:,34) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) intervention./alldata(:,34) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) intervention./alldata(:,34) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1) zeros(nHH,1); ...
   zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) intervention./alldata(:,34) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) zeros(nHH,1) ones(nHH,1)];

%now run some regressions;
for k=1:S2
    Ym=[Ydata(1:4*nHH);Y6(:,k);Y7(:,k);Y8(:,k);Y9(:,k);Y10(:,k);Y11(:,k);Y12(:,k)];
    Ygrowthm=[Ygrowthdata(1:4*nHH); log(Y6(:,k)./alldata(:,5)); log(Y7(:,k)./Y6(:,k)); log(Y8(:,k)./Y7(:,k)); log(Y9(:,k)./Y8(:,k)); log(Y10(:,k)./Y9(:,k)); log(Y11(:,k)./Y10(:,k)); log(Y12(:,k)./Y11(:,k))];
    Im=[Idata(1:4*nHH); I6(:,k); I7(:,k); I8(:,k); I9(:,k); I10(:,k); I11(:,k); I12(:,k)];
    Dm=[Ddata(1:4*nHH); d6(:,k); d7(:,k); d8(:,k); d9(:,k); d10(:,k); d11(:,k); d12(:,k)];
    DEFm=[DEFdata(1:4*nHH); def6(:,k); def7(:,k); def8(:,k); def9(:,k); def10(:,k); def11(:,k); def12(:,k)];
    Cm=[Cdata(1:4*nHH);C6(:,k);C7(:,k);C8(:,k);C9(:,k);C10(:,k);C11(:,k);C12(:,k)];
    
    betaCm(:,k)=inv(X'*X)*X'*Cm;
    sig2Cm=mean((Cm-X*betaCm(:,k)).^2);
    stdbetaCm(:,k)=diag(sig2Cm*inv(X'*X)).^0.5;
    betaDm(:,k)=inv(X'*X)*X'*Dm;
    sig2Dm=mean((Dm-X*betaDm(:,k)).^2);
    stdbetaDm(:,k)=diag(sig2Dm*inv(X'*X)).^0.5;
    betaIm(:,k)=inv(X'*X)*X'*Im;
    sig2Im=mean((Im-X*betaIm(:,k)).^2);
    stdbetaIm(:,k)=diag(sig2Im*inv(X'*X)).^0.5;
    betaDEFm(:,k)=inv(X'*X)*X'*DEFm;
    sig2DEFm=mean((DEFm-X*betaDEFm(:,k)).^2);
    stdbetaDEFm(:,k)=diag(sig2DEFm*inv(X'*X)).^0.5;
    betaYgrowthm(:,k)=inv(X'*X)*X'*Ygrowthm;
    sig2Ygrowthm=mean((Ygrowthm-X*betaYgrowthm(:,k)).^2);
    stdbetaYgrowthm(:,k)=diag(sig2Ygrowthm*inv(X'*X)).^0.5; 
    
end;
diary Section543_longrun.txt;

comparebetaCm=[mean(stdbetaCm,2) mean(betaCm,2)];
comparebetaCmmain1=comparebetaCm(1,:) %1st year coefficients
comparebetaCmmain4=comparebetaCm(4,:) %4th year coefficients
comparebetaCmmain7=comparebetaCm(7,:) %7th year coefficients
comparebetaDm=[mean(stdbetaDm,2) mean(betaDm,2)];
comparebetaDmmain1=comparebetaDm(1,:) %1st year coefficients
comparebetaDmmain4=comparebetaDm(4,:) %4th year coefficients
comparebetaDmmain7=comparebetaDm(7,:) %7th year coefficients
comparebetaIm=[mean(stdbetaIm,2) mean(betaIm,2)];
comparebetaImmain1=comparebetaIm(1,:) %1st year coefficients
comparebetaImmain4=comparebetaIm(4,:) %4th year coefficients
comparebetaImmain7=comparebetaIm(7,:) %7th year coefficients
comparebetaDEFm=[mean(stdbetaDEFm,2) mean(betaDEFm,2)];
comparebetaDEFmmain1=comparebetaDEFm(1,:)       %1st year coefficients
comparebetaDEFmmain4=comparebetaDEFm(4,:) %4th year coefficients
comparebetaDEFmmain7=comparebetaDEFm(7,:)       %7th year coefficients
comparebetaYgrowthm=[mean(stdbetaYgrowthm,2) mean(betaYgrowthm,2)];
comparebetaYgrowthmmain1=comparebetaYgrowthm(1,:)       %1st year coefficients
comparebetaYgrowthmmain4=comparebetaYgrowthm(4,:)       %4th year coefficients
comparebetaYgrowthmmain7=comparebetaYgrowthm(7,:)       %7th year coefficients

diary off;


save millbahtlongrun;



        
 
        