

*now run regressions; 
*log income;

xtreg ly ib107o(127 149 153 607 627 627 649 653 707 727 749 753).yrchang ageh agehsq maleh madult fadult kids educh if year<=5, i(case_id) fe;

egen agehb1=mean(ageh) if e(sample);
egen agehb=mean(agehb1);
egen agehsqb1=mean(agehsq) if e(sample);
egen agehsqb=mean(agehsqb1);
egen educhb1=mean(educh) if e(sample);
egen educhb=mean(educhb1);
egen malehb1=mean(maleh) if e(sample);
egen malehb=mean(malehb1);
egen madultb1=mean(madult) if e(sample);
egen madultb=mean(madultb1);
egen fadultb1=mean(fadult) if e(sample);
egen fadultb=mean(fadultb1);
egen kidsb1=mean(kids) if e(sample);
egen kidsb=mean(kidsb1);


foreach i in 127 149 153 207 227 249 253 307 327 349 353 407 427 449 453 507 527 549 553 {;
	summ `i'.yrchang if e(sample);
	local mean`i'e = r(mean);
};


gen ch07h=`mean207e'*[#1]207.yrchang+`mean307e'*[#1]307.yrchang+`mean407e'*[#1]407.yrchang+`mean507e'*[#1]507.yrchang if e(sample);
gen ch27h=`mean227e'*[#1]227.yrchang+`mean327e'*[#1]327.yrchang+`mean427e'*[#1]427.yrchang+`mean527e'*[#1]527.yrchang if e(sample);
gen ch49h=`mean249e'*[#1]249.yrchang+`mean349e'*[#1]349.yrchang+`mean449e'*[#1]449.yrchang+`mean549e'*[#1]549.yrchang if e(sample);
gen ch53h=`mean253e'*[#1]253.yrchang+`mean353e'*[#1]353.yrchang+`mean453e'*[#1]453.yrchang+`mean553e'*[#1]553.yrchang if e(sample);

