function [c,x,v] = dpsolvenew(model,fspace,snodes,s,vin,xin);
global c cE x vE
maxit=model.maxit;
tol=model.tol;
istarvals2=model.istarvals2;
istarvals=model.istarvals;
slbar=model.slbar;
clbar=model.clbar;
%the initial collocation parameters from initial guess
c=funfitxy(fspace,snodes,vin);
cE=c; %initialize cE
%solve c by function iteration using Howard's improvement algorithm
deviation=zeros(maxit,1);
highval=zeros(maxit,1);
furthestoff=zeros(maxit,1);

for it=1:maxit

    cold = c;   
    if mod(it-1,10)==0
        xold=xin;
        vE=valfuncREalt(c,cE,s,fspace,model);
        cE=funfitxy(fspace,snodes,vE);
        [v,x] = solveRsimplexalt(model,fspace,s,xin,c,cE);
        xin=x;
    else
        vE=valfuncREalt(c,cE,s, fspace,model);
        cE=funfitxy(fspace,snodes,vE);
        v=valfuncRalt(xin,s,c,cE,fspace,model);
    end;
    c=funfitxy(fspace,snodes,v);
    
   [highval(it) furthestoff(it)]=max(abs((xold-xin)./(max([xin ones(size(xin))]'))'));
    it=it;
    highvalrecent=highval(it);
    if highval(it)<tol,break,end;
end