%This routine calculates the weighted sum of empirical moment values, i.e.,
%the objective of the GMM. It requires the compecon
%toolbox of Miranda and Fackler, available at
%http://www4.ncsu.edu/~pfackler/compecon/
%It calls the routine separatemomentslevels.m,
%and it requires a parameter vector as input. 

function [summedeps] = summedmomentslevels(theta)
global predata weightmat nHH R

raweps=zeros(nHH,16);
raweps=separatemomentslevels(theta);
omega=1/nHH*raweps'*raweps;
weightmat=inv(omega);
eps=sum(raweps)/nHH;
summedeps=eps*weightmat*eps';
theta=theta
summedeps=summedeps