%This evaluate the value function at a particular consumption and
%investment decision
function v = valfuncR(x,s,c,cE,fspace,model);
rho=model.rho;   

excliq=((1-rho)*s(:,1)).^(1/(1-rho))+model.slbar+model.clbar-0.01;  %liquidity after investing
f1=(x).^(1-rho)/(1-rho);

lprimetrans=(excliq-x-model.slbar+0.01).^(1-rho)/(1-rho);
Ev=funeval(cE,fspace,[lprimetrans s(:,2)]);
v=f1+Ev;

